# Trellis 2 API

> แปลงภาพเดียวเป็นเมช 3D GLB ที่มีพื้นผิว พร้อมการตั้งค่าโครงสร้าง รูปร่าง พื้นผิว และ UV ที่ปรับได้

สร้างแอสเซ็ต 3D จากรูปภาพหนึ่งรูป (`image_url`) และส่งคืนไฟล์ GLB `resolution` คือ 512, 1024 หรือ 1536 และ `texture_size` คือ 1024, 2048 หรือ 4096 แต่ละระยะจากทั้งหมดสามระยะ (โครงสร้าง รูปร่าง เท็กซ์เจอร์) มีการควบคุมการชี้นำและขั้นตอนการสุ่มตัวอย่างแยกกัน `decimation_target` กำหนดจำนวนจุดยอดของเมช (5,000 ถึง 2,000,000) และมีตัวเลือกสำหรับการสร้างเมชใหม่รวมถึงการคลี่ UV

- Model id: `trellis-2`
- Made by: Microsoft
- Category: Image to 3D
- Output: 3d
- Price: from $0.25 / request (cheapest run $0.25 (250 API credits))
- Run: `POST https://api.doitong.com/v1/run/trellis-2`
- Quote: `POST https://api.doitong.com/v1/quote/trellis-2`
- Docs page: https://doitong.com/th/developers/models/trellis-2

## Pricing

Price: **from $0.25 / request** (the lowest tier; the quote prices your exact input). Billed once per request.

Price rules (the first rule that matches the input wins; a parameter you leave out counts as its default):

- When `resolution` = 1024: $0.30 (300 API credits) / request
- When `resolution` = 1536: $0.35 (350 API credits) / request

The full example input below costs $0.30 = 300 API credits (1 request × 300 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/trellis-2` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `seed` |  | integer \| null | no |  |  | Seed ที่ใช้สำหรับการสร้างแบบสุ่มซึ่งทำซ้ำผลลัพธ์ได้ |
| `resolution` |  | enum (integer) | no | `1024` | `512`, `1024`, `1536` | ความละเอียดของเอาต์พุต การเพิ่มค่าจะเพิ่มรายละเอียดแต่ใช้เวลานานขึ้น |
| `ss_guidance_strength` |  | number | no | `7.5` | 0 – 10 | การควบคุมความเที่ยงตรงของโครงสร้าง 3D เริ่มต้น การเพิ่มค่าจะทำให้สอดคล้องกับรูปภาพอินพุตมากขึ้น แต่อาจมีสัญญาณรบกวนเพิ่มขึ้น |
| `ss_guidance_rescale` |  | number | no | `0.7` | 0 – 1 | การควบคุมสิ่งแปลกปลอมจากการกำกับในขั้นที่ 1 โดยค่าต่ำให้ผลของการกำกับที่แรงกว่า ส่วนค่าสูงให้เอาต์พุตที่เสถียรกว่า |
| `ss_guidance_interval_start` |  | number | no | `0.6` | 0 – 1 | ขอบเขตเริ่มต้นของช่วงการชี้นำแบบ classifier-free ใน stage 1 (โครงสร้างแบบเบาบาง) แสดงเป็นสัดส่วนของการลดสัญญาณรบกวน ค่าที่ต่ำกว่าจะเริ่มการชี้นำเร็วขึ้น โดยมีเพียงช่วงตั้งแต่ interval_start ถึง interval_end เท่านั้นที่ใช้การชี้นำ ส่วนช่วงอื่นจะประมวลผลโดยไม่มีการชี้นำ |
| `ss_guidance_interval_end` |  | number | no | `1` | 0 – 1 | จุดสิ้นสุดการชี้นำสำหรับ stage 1 (โครงสร้างแบบเบาบาง): เลือกค่าที่มากกว่าหรือเท่ากับ ss_guidance_interval_start ค่านี้ระบุสัดส่วนของการลดสัญญาณรบกวนที่ทำได้เมื่อการชี้นำแบบ classifier-free หยุดทำงาน |
| `ss_sampling_steps` |  | integer | no | `12` | 1 – 50 | จำนวนครั้งการลดสัญญาณรบกวนของโครงสร้างเริ่มต้น การเพิ่มขั้นตอนอาจเพิ่มคุณภาพ แต่ทำให้ประมวลผลช้าลง |
| `ss_rescale_t` |  | number | no | `5` | 1 – 6 | กำหนดความคมชัดของการเปลี่ยนผ่านผ่านตารางเวลาสัญญาณรบกวนของการสร้างโครงสร้าง การเพิ่มค่านี้ทำให้การเปลี่ยนผ่านคมชัดขึ้น |
| `shape_slat_guidance_strength` |  | number | no | `7.5` | 0 – 10 | การควบคุมความเที่ยงตรงของเรขาคณิตโดยละเอียด การเพิ่มความสอดคล้องกับรูปภาพอินพุตจะเพิ่มรายละเอียด แต่อาจมีสัญญาณรบกวนเพิ่มขึ้น |
| `shape_slat_guidance_rescale` |  | number | no | `0.5` | 0 – 1 | เพิ่มค่านี้เมื่อเรขาคณิตมีสัญญาณรบกวน เพื่อลดสิ่งแปลกปลอมที่เกิดจากการกำกับอย่างแรงระหว่างขั้นตอนสร้างรูปร่าง |
| `shape_slat_guidance_interval_start` |  | number | no | `0.6` | 0 – 1 | จุดเปิดใช้การชี้นำแบบ classifier-free สำหรับการปรับปรุงรูปร่างใน stage 2 แสดงเป็นสัดส่วนของความคืบหน้าการลดสัญญาณรบกวน โดยกำหนดค่า interval_start และการชี้นำจะทำงานเฉพาะภายในช่วงที่มี interval_start และ interval_end เป็นขอบเขต |
| `shape_slat_guidance_interval_end` |  | number | no | `1` | 0 – 1 | จุดสิ้นสุดการชี้นำสำหรับ stage 2 (การปรับปรุงรูปร่าง): เลือกค่าที่มากกว่าหรือเท่ากับ shape_slat_guidance_interval_start ค่านี้ระบุสัดส่วนของการลดสัญญาณรบกวนที่ทำได้เมื่อการชี้นำแบบ classifier-free หยุดทำงาน |
| `shape_slat_sampling_steps` |  | integer | no | `12` | 1 – 50 | จำนวนครั้งการลดสัญญาณรบกวนเพื่อปรับแต่งรูปร่าง เรขาคณิตอาจเรียบขึ้น แต่การเพิ่มขั้นตอนจะทำให้ความเร็วลดลง |
| `shape_slat_rescale_t` |  | number | no | `3` | 1 – 6 | กำหนดความคมชัดของรายละเอียดเรขาคณิตผ่านตารางเวลาสัญญาณรบกวนของการปรับแต่งรูปร่าง การเพิ่มค่านี้ให้รายละเอียดที่คมชัดขึ้น |
| `tex_slat_guidance_strength` |  | number | no | `1` | 0 – 10 | การควบคุมความเที่ยงตรงของสีพื้นผิว การยึดตามสีในรูปภาพอินพุตมากขึ้นที่ค่าระดับสูงจะเพิ่มความสดของสี แต่อาจทำให้สีอิ่มตัวเกินไป |
| `tex_slat_guidance_rescale` |  | number | no | `0` | 0 – 1 | เพิ่มค่านี้เพื่อแก้ไขพื้นผิวที่มีสัญญาณรบกวนหรือแถบสี เพื่อลดสิ่งแปลกปลอมที่เกิดจากการกำกับอย่างแรงระหว่างขั้นตอนสร้างพื้นผิว |
| `tex_slat_guidance_interval_start` |  | number | no | `0.6` | 0 – 1 | จุดเปิดใช้การชี้นำแบบ classifier-free สำหรับการสร้างพื้นผิวใน stage 3 แสดงเป็นสัดส่วนของความคืบหน้าการลดสัญญาณรบกวน โดยกำหนดค่า interval_start และการชี้นำจะทำงานเฉพาะภายในช่วงที่มี interval_start และ interval_end เป็นขอบเขต |
| `tex_slat_guidance_interval_end` |  | number | no | `0.9` | 0 – 1 | จุดสิ้นสุดการชี้นำสำหรับ stage 3 (พื้นผิว): เลือกค่าที่มากกว่าหรือเท่ากับ tex_slat_guidance_interval_start ค่านี้ระบุสัดส่วนของการลดสัญญาณรบกวนที่ทำได้เมื่อการชี้นำแบบ classifier-free หยุดทำงาน |
| `tex_slat_sampling_steps` |  | integer | no | `12` | 1 – 50 | จำนวนขั้นตอนการลดสัญญาณรบกวนที่ใช้สร้างพื้นผิว การเพิ่มจำนวนขั้นตอนใช้เวลานานขึ้น แต่อาจได้พื้นผิวที่สะอาดขึ้น |
| `tex_slat_rescale_t` |  | number | no | `3` | 1 – 6 | กำหนดความคมชัดของรายละเอียดพื้นผิวผ่านตารางเวลาสัญญาณรบกวนของการสร้างพื้นผิว การเพิ่มค่านี้ให้รายละเอียดที่คมชัดขึ้น |
| `decimation_target` |  | integer | no | `500000` | 5,000 – 2,000,000 | เป้าหมายจำนวนจุดยอดของเมช โดยแนะนำให้ใช้ 500k สำหรับการใช้งานทั่วไป และ 20k–50k สำหรับเว็บ/มือถือ การลดเป้าหมายจะแลกกับรายละเอียดเมชที่ลดลงเพื่อให้ได้ไฟล์ขนาดเล็กลง |
| `texture_size` |  | enum (integer) | no | `2048` | `1024`, `2048`, `4096` | ความละเอียดพื้นผิวเมชสำหรับการอบพื้นผิว รายละเอียดพื้นผิวที่ละเอียดขึ้นจะทำให้ไฟล์ใหญ่ขึ้นเมื่อเพิ่มความละเอียดนี้ |
| `remesh` |  | boolean | no | `true` |  | การสร้างโทโพโลยีใหม่เพื่อสร้างสามเหลี่ยมของเมชที่สะอาดขึ้น ซึ่งโดยทั่วไปจะทำให้เหมาะกับการใช้งานต่อ เช่น แอนิเมชันหรือการพิมพ์ 3D มากขึ้น โดยแลกกับเวลาในการประมวลผลที่นานขึ้น |
| `remesh_band` |  | number | no | `1` | 0 – 4 | ขอบเขตการเคลื่อนที่ในการสร้างเมชใหม่: การปรับให้เรียบเพิ่มเติมอาจทำให้รายละเอียดเล็กสูญเสียไปเมื่อเพิ่มค่านี้ การตั้งค่านี้จำกัดการเลื่อนของจุดยอดเทียบกับพื้นผิวเดิม |
| `remesh_project` |  | number | no | `0` | 0 – 1 | ความแรงของการฉายเพื่อดึงจุดยอดที่สร้างเมชใหม่กลับไปยังพื้นผิวเดิม: ค่า 1 จะรักษารายละเอียดด้วยการฉายเต็มรูปแบบ ส่วนค่า 0 จะปิดการฉายเพื่อให้ได้ผลลัพธ์ที่เรียบกว่า |
| `uv_unwrap_angle_threshold_deg` |  | number | no | `90` | 0 – 180 | ขีดจำกัดมุมของชาร์ต UV เป็นองศา จำกัดความแตกต่างของนอร์มัลของพื้นผิวที่อยู่ติดกันภายในชาร์ตเดียว การเพิ่มค่าจะให้ความสำคัญกับชาร์ตที่น้อยลงและใหญ่ขึ้น แต่อาจทำให้เกิดการยืด ส่วนการลดค่าจะให้ชาร์ตมากขึ้นและการบิดเบือนน้อยลง |
| `uv_unwrap_refine_iterations` |  | integer | no | `0` | 0 – 10 | จำนวนรอบการปรับรายละเอียดเฉพาะที่ที่ใช้คำนวณชาร์ต UV |
| `uv_unwrap_global_iterations` |  | integer | no | `1` | 1 – 10 | ปรับสมดุลชาร์ต UV ได้โดยเพิ่มจำนวนรอบการจัดกลุ่มทั่วโลกที่ใช้คำนวณชาร์ต |
| `uv_unwrap_smooth_strength` |  | number | no | `1` | 0 – 10 | ปรับระดับการทำให้ขอบชาร์ต UV เรียบ ยิ่งตั้งค่าสูง รอยต่อจะเห็นได้น้อยลง แต่อาจเกิดการบิดเบือนของ UV |
| `image_url` | `image` | string (image URL) | yes |  |  | URL ที่ชี้ไปยังรูปภาพต้นทางสำหรับการแปลงเป็น 3D |

File parameters (`image`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "image": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

A fuller example:

```json
{
  "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/trellis-2?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/trellis-2?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/trellis-2", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "trellis-2",
      "input": {
        "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "trellis-2",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 300,
    "usd": "0.30",
    "charged": 300,
    "refunded": 0
  },
  "input": {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  },
  "output": {
    "model_glb": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    }
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `model_glb` | object {url, content_type, file_name, file_size} | โมเดล 3D ที่สร้างในรูปแบบ GLB |

## Related models

- [Trellis 2 · Retexture](https://doitong.com/developers/models/trellis-2/retexture.md) (`trellis-2/retexture`): from $0.20 / request
- [Trellis](https://doitong.com/developers/models/trellis.md) (`trellis`): $0.02 / request
- [Trellis · Multi](https://doitong.com/developers/models/trellis/multi.md) (`trellis/multi`): $0.02 / request
- [TRELLIS.2 LoRA Inference](https://doitong.com/developers/models/trellis-2-lora.md) (`trellis-2-lora`): from $0.25 / request
- [Hi3D Image to 3D](https://doitong.com/developers/models/hitem3d/hi3d/image-to-3d.md) (`hitem3d/hi3d/image-to-3d`): $0.50 / run
- [Hi3D Image to 3D · v3.0](https://doitong.com/developers/models/hitem3d/hi3d/v3.0/image-to-3d.md) (`hitem3d/hi3d/v3.0/image-to-3d`): from $1.80 / run
- [Hi3D Multiview to 3D · Multi View to 3D](https://doitong.com/developers/models/hitem3d/hi3d/multi-view-to-3d.md) (`hitem3d/hi3d/multi-view-to-3d`): $0.50 / run
- [Hi3D Multiview to 3D · v3.0 · Multi View to 3D](https://doitong.com/developers/models/hitem3d/hi3d/v3.0/multi-view-to-3d.md) (`hitem3d/hi3d/v3.0/multi-view-to-3d`): from $1.80 / run

## Links

- HTML page: https://doitong.com/developers/models/trellis-2
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=trellis-2
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/trellis-2
